//************************************************************************
//                                                                         
//        {nnpW琢EnnpWւ̕ϊvO(Ql) 
//
//      Ver. 1.0    2020/11/02          By   takesako@mrj.biglobe.ne.jp    
//                                           (c) Shinobu Takesako          
//
//ŗ
//ver. 1.0 2020/11/02 [X 
//*************************************************************************

#include <stdio.h>
#include <math.h>


#define pai (3.1415926535897932/180.0)

// {̍Wn(_)
double zone[20][2]={
	{0.0			, 0.0},//0
	{129.0+30.0/60.0,33.0},//1n 茧@n
	{131.0			,33.0},//2n  ꌧ F{ 啪 {茧 {y
	{132.0+10.0/60.0,36.0},//3n R@@L
	{133.0+30.0/60.0,33.0},//4n 쌧 Q@@m
	{134.0+20.0/60.0,36.0},//5n Ɍ@挧@R
	{136.0			,36.0},//6n s{@{@䌧@ꌧ@Od@ޗǌ@a̎R
	{137.0+10.0/60.0,36.0},//7n ΐ쌧@xR@򕌌@m
	{138.0+30.0/60.0,36.0},//8n V@쌧@R@É
	{139.0+50.0/60.0,36.0},//9n s  Ȗ، 錧 ʌ t Qn _ސ쌧
	{140.0+50.0/60.0,40.0},//10n X Hc R` 茧 {錧
	{140.0+15.0/60.0,44.0},//11n kC
	{142.0+15.0/60.0,44.0},//12n kC
	{144.0+15.0/60.0,44.0},//13n kC
	{142.0			,26.0},//14n }
	{127.0+30.0/60.0,26.0},//15n ꌧ
	{124.0			,26.0},//16n {ÏAǊԓA[A^ߍAΊ_A|xA\
	{131.0			,26.0},//17n k哌A哌
	{136.0			,20.0},//18n m
	{154.0			,26.0},//19n 쒹
};


//**********************************************************************************
//   atanh( )͎̌𗘗pċ߂B
//
//**********************************************************************************

double atanh (double x)
{
	double a;	
	a = log((1.0 + x) / (1.0 - x)) / 2.0 ; 
    return a;
}

/*******************************************************************************/
/*                      x\xb\ւ̕ϊ                           */
/*******************************************************************************/

double DegToDMS(double D)

{
	int    flag=0;
	double Deg,Min,Sec,H;
	
	if(D<0) {
	D=-D;
	flag=1;
	};
	Deg   = floor(D);
	Min   = floor((D - Deg)*60.0);
	Sec   = (D*3600-Deg*3600-Min*60);
	H     = Deg +  Min/100.0 + Sec/10000.0;
	if(flag==1)H=-H;
    return H;
}


//**********************************************************************************
//   ܓxoxyу\[畽ʒpWyѕΈʊp擾
//   ({nB͈ȉQƁB)
// https://vldb.gsi.go.jp/sokuchi/surveycalc/surveycalc/algorithm/bl2xy/bl2xy.htm
//**********************************************************************************
void DesToUTM( double latitude, double longitude, double Zone,int std, double *E, double *N ,double *gam)
{
	double f,r,n,A[6],Am,n1,n2,n3,n4,n5,n6;
	double lon0,lon,lat0,lat,gd,ed,E0,N0,k0,t,tm;
	double a[6];
	double tau,del,lamc,lams,Smlat,rk0;
	int	i;

	if(std == 0){
		f = 1.0/ (298.257222101);//Enn(GRS80 n̝G)
		r = 6378137.0000;        //Enn(GRS80 & WGS84 nӔa)
		}
	else{
		f = 1.0/ (299.152813);// {nn(Besselȉ~)
		r = 6377397.1550;     // {nn(Besselȉ~)
	}

	E0 = 0.0;// oxItZbg
	N0 = 0.0;// ܓxItZbg
//	k0 = 0.9996;//UTMWn̏ꍇ
	k0 = 0.9999;//yn@

	n = f/(2.0-f);
	n1=n;
	n2=n1*n;
	n3=n2*n;
	n4=n3*n;
	n5=n4*n;
	n6=n5*n;
	A[0] =  1 + n2/4.0 + n4/64.0 ;
	rk0  = r*k0/(1+n1);
	Am   = rk0*A[0];

	A[1] = -3.0/2.0* (n1 - n3/8.0 -n5/64.0);
	A[2] = 15.0/16.0* (n2 - n4/4.0);
	A[3] = -35.0/48.0 * (n3 -5.0/16.0*n5);
	A[4] = 315.0/512.0 *n4;
	A[5] = -693.0/1280.0 *n5;

	a[1] = 1.0/2.0*n1 - 2.0/3.0 *n2 + 5.0/16.0*n3 +41.0/180.0*n4 - 127.0/288.0*n5;
	a[2] = 13.0/48.0*n2- 3.0/5.0*n3 + 557.0/1440.0*n4 +281.0/630.0*n5;
	a[3] = 61.0/240.0*n3 - 103.0/140.0*n4 + 15061.0/26880.0*n5;
	a[4] = 49561.0/161280.0*n4 -179.0/168.0*n5;
	a[5] = 34729.0/80640.0*n5;

	lon0 = zone[(int)Zone][0];
	lat0 = zone[(int)Zone][1];

	lon0 = lon0*pai;
	lat0 = lat0*pai;

	lon  = longitude*pai;
	lat  = latitude*pai;

	//ܓx_̒̌vZ
	Smlat = Am*lat0;
	for(i=1;i<=5;i++){
	Smlat = Smlat + rk0*A[i]*sin(2.0*((double)i)*lat0) ;
	}

	t  = sinh (atanh (sin(lat)) - 2*sqrt(n)/(1.0+n) *atanh( 2*sqrt(n)/(1.0+n) * sin(lat)) ) ;
	tm = sqrt(1+t*t);
	gd = atan (t/(cos(lon-lon0)));
	ed = atanh (sin(lon-lon0)/sqrt(1+t*t));

	*E =E0 + Am*ed;
	*N =N0 + Am*gd;

	for(i=1;i<=5;i++){
	*E = *E + Am*a[i]*cos(2.0*((double)i)*gd)*sinh(2.0*((double)i)*ed) ;
	*N = *N + Am*a[i]*sin(2.0*((double)i)*gd)*cosh(2.0*((double)i)*ed) ;
	}
	*N = *N - Smlat;// ܓx_̒

	// ^kp()߂B(vX͐^k萼C}CiX͓)

	del = 1.0;
	tau = 0.0;

	for(i=1;i<=5;i++){
	del = del + 2.0*((double)i)*a[i]*cos(2.0*((double)i)*gd)*cosh(2.0*((double)i)*ed) ;
	tau = tau + 2.0*((double)i)*a[i]*sin(2.0*((double)i)*gd)*sinh(2.0*((double)i)*ed) ;
	}

	lamc=cos(lon-lon0);
	lams=sin(lon-lon0);

	*gam=-atan( (tau*tm*lamc+del*t*lams)/(del*tm*lamc-tau*t*lams) )/pai*60.0;

}



//**********************************************************************************
//   ʒpWyу][ܓxox擾
//   ({nB͈ȉQƁB)
// https://vldb.gsi.go.jp/sokuchi/surveycalc/surveycalc/algorithm/xy2bl/xy2bl.htm
//**********************************************************************************

void UTMToDes(double E, double N, double Zone,int std, double *latitude, double *longitude )
{
	double f,r,n,A[6],Am,n1,n2,n3,n4,n5,n6;
	double lon0,lat,lat0,gd,ed,E0,N0,k0,g,e,kai,rk0,Smlat;
	double b[6],d[7];
	int	i;

	if(std == 0){
		f = 1.0/ (298.257222101);//Enn(GRS80 n̝G)
		r = 6378137.0000;        //Enn(GRS80 & WGS84 nӔa)
		}
	else{
		f = 1.0/ (299.152813);// {nn(Besselȉ~)
		r = 6377397.1550;     // {nn(Besselȉ~)
	}
 

	E0 = 0.0;// oxItZbg
	N0 = 0.0;// ܓxItZbg
//	k0 = 0.9996;//UTMWn̏ꍇ
	k0 = 0.9999;//yn@

	n = f/(2.0-f);
	n1=n;
	n2=n1*n;
	n3=n2*n;
	n4=n3*n;
	n5=n4*n;
	n6=n5*n;
	A[0] =  1 + n2/4.0 + n4/64.0 ;
	rk0  = r*k0/(1+n1);
	Am   = rk0*A[0];

	A[1] = -3.0/2.0* (n1 - n3/8.0 -n5/64.0);
	A[2] = 15.0/16.0* (n2 - n4/4.0);
	A[3] = -35.0/48.0 * (n3 -5.0/16.0*n5);
	A[4] = 315.0/512.0 *n4;
	A[5] = -693.0/1280.0 *n5;

	b[1] = 1.0/2.0*n1 -2.0/3.0*n2 + 37.0/96.0 *n3 - 1.0/360.0*n4 - 81.0/512.0*n5;
	b[2] = 1.0/48.0*n2 +1.0/15.0*n3 -437.0/1440.0*n4 +46.0/105.0*n5;
	b[3] = 17.0/480.0 *n3 -37.0/840.0*n4 -209.0/4480.0*n5;
	b[4] = 4397.0/161280.0*n4 - 11.0/504.0*n5;
	b[5] = 4583.0/161280.0*n5;

	d[1] = 2.0*n-2.0/3.0*n2-2.0*n3 +116.0/45.0*n4+26.0/45.0*n5-2854.0/675.0*n6;
	d[2] = 7.0/3.0*n2 - 8.0/5.0*n3 -227.0/45.0*n4 + 2704.0/315.0*n5 + 2323.0/945.0*n6;
	d[3] = 56.0/15.0 *n3 -136.0/35.0*n4 -1262.0/105.0*n5 +73814.0/2835.0*n6;
	d[4] = 4279.0/630.0*n4 -332.0/35.0*n5 - 399572.0/14175.0*n6;
	d[5] = 4174.0/315.0*n5 -144838.0/6237*n6;
	d[6] = 601676.0/22275.0*n6;

	lon0 = zone[(int)Zone][0];
	lat0 = zone[(int)Zone][1];
	
	lat0 = lat0*pai;

	//ܓx_̒̌vZ
	Smlat = Am*lat0;
	for(i=1;i<=5;i++){
	Smlat = Smlat + rk0*A[i]*sin(2.0*((double)i)*lat0) ;
	}

	g = (N-N0+Smlat)/(Am);
	e = (E-E0)/(Am);

	gd=g;
	ed=e;

	for(i=1;i<=5;i++){
	gd = gd - b[i]*sin(2.0*((double)i)*g)*cosh(2.0*((double)i)*e) ;
	ed = ed - b[i]*cos(2.0*((double)i)*g)*sinh(2.0*((double)i)*e) ;
	}

	kai = asin (sin(gd)/cosh(ed));
	lat = kai;
	for(i=1;i<=6;i++){
	lat = lat + d[i]*sin(2.0*((double)i)*kai);
	}

 	*latitude	= lat/pai;
	*longitude  = lon0 + atan(sinh(ed)/cos(gd))/pai;  

}



void CorToxyz(double lon, double lat,double h, int std, double *x ,double *y, double *z)
{

	double f,r,e2,N,sinlon,coslon,sinlat,coslat;

	if(std == 0){
		r = 6378137.000;        //Enn(GRS80 & WGS84 nӔa)
		f = 1.0/ (298.257222101);//Enn(GRS80 n̝G)
		}
	if(std == 1){
		r = 6377397.1550;     // {nn(Besselȉ~)
		f = 1.0/ (299.152813);// {nn(Besselȉ~)
	}

//	printf("01@%13.9f %13.9f \n\n",DegToDMS(lat), DegToDMS(lon));
	sinlon = sin(lon*pai);
	coslon = cos(lon*pai);
	sinlat = sin(lat*pai);
	coslat = cos(lat*pai);

	e2 = f*(2.0-f); 
	N  = r /sqrt( 1.0 - e2* sinlat*sinlat);

	// rSWւ̕ϊ
	*x =(N+h)*coslat*coslon;
	*y =(N+h)*coslat*sinlon;
	*z =(N*(1-e2)+h)*sinlat;
//	printf("02 x=%15.4f y=%15.4f z=%15.4f\n",*x,*y,*z);
}


void xyzToCor(double x ,double y, double z, int std, double *lon, double *lat )
{

double f,r,e2,e2d,P,the;


//WEoܓxϊ
	if(std == 1){
		r = 6378137.0000;        //Enn(GRS80 & WGS84 nӔa)
		f = 1.0/ (298.257222101);//Enn(GRS80 n̝G)
		}
	if(std == 0){
		r = 6377397.1550;     // {nn(Besselȉ~)
		f = 1.0/ (299.152813);// {nn(Besselȉ~)
	}
		
	e2 = f*(2.0-f); 
	e2d=e2/(1.0-e2);
	P = sqrt(x*x + y*y);
	the= atan2(z,P*(1.0-f));
// Bowring̎@
	*lon=atan2(y,x)/pai;
	*lat=atan2(z+e2d*r*(1.0-f)*sin(the)*sin(the)*sin(the) , P-e2*r*cos(the)*cos(the)*cos(the))/pai;

}


void delta_xyz(double lon1, double lat1, double lon2, double lat2, double *dx, double *dy, double *dz)
{
	double x1,x2,y1,y2,z1,z2,h0;
	int std;

	h0=0.0;

	std=1;
	CorToxyz( lon1, lat1, h0,std,&x1,&y1,&z1);
//	printf("x1=%8.3f y1=%8.3f z1=%8.3f\n",x1,y1,z1);

	std=0;
	CorToxyz( lon2, lat2, h0,std,&x2,&y2,&z2);
//	printf("x2=%8.3f y2=%8.3f z2=%8.3f\n",x2,y2,z2);

	*dx=x2-x1;
	*dy=y2-y1;
	*dz=z2-z1;

}


//**********************************************************************************
//   {nnVEnnւ̕ϊ(QlvO)
//**********************************************************************************

void JpnToGen(double E0, double N0, double Zone, double *E, double *N, double *lat, double *lon, double *gam)
{

	double lon1, lat1, lon2, lat2, dx, dy, dz, ddx, ddy, ddz,h0,lat0,lon0;
	double x1,x2,y1,y2,z1,z2,E2,N2,gam2;
	int std;

	//lon1=139.0+44.0/60.0+40.51748/3600.0;//{(TOKYO) {oܓx_
	//lat1= 35.0+39.0/60.0+17.49597/3600.0;
	//lon2=139.0+44.0/60.0+28.88690/3600.0;//E
	//lat2= 35.0+39.0/60.0+29.15720/3600.0;
	//dx=-123.861 dy= 488.204 dz= 659.013

	lon1=135.0+45.0/60.0+10.20829/3600.0;//{(TOKYO) s
	lat1= 34.0+59.0/60.0+48.38775/3600.0;
	lon2=135.0+45.0/60.0+ 0.00000/3600.0;//E
	lat2= 35.0+00.0/60.0+ 0.00000/3600.0;
	// dx=-119.332 dy= 477.603 dz= 653.823

	//lon1=135.0+44.0/60.0+33.47/3600.0;//{(TOKYO) 
	//lat1= 35.0+01.0/60.0+05.72/3600.0;
	//lon2=135.0+44.0/60.0+23.26339/3600.0;//E
	//lat2= 35.0+01.0/60.0+17.32521/3600.0;
	//dx=-119.230 dy= 477.454 dz= 653.775//sʂ

	//lon1=135.0+47.0/60.0+50.06/3600.0;//{(TOKYO) 
	//lat1= 34.0+41.0/60.0+33.38/3600.0;
	//lon2=135.0+47.0/60.0+39.85138/3600.0;//E
	//lat2= 34.0+41.0/60.0+45.10635/3600.0;
	//dx=-120.182 dy= 479.320 dz= 654.858//鋞ɓa

	//lon1=135.0+49.0/60.0+15.15/3600.0;//{(TOKYO) 鋞ɓa
	//lat1= 34.0+28.0/60.0+23.48/3600.0;
	//lon2=135.0+49.0/60.0+04.94731/3600.0;//E
	//lat2= 34.0+28.0/60.0+35.29759/3600.0;
	//dx=-120.735 dy= 480.358 dz= 655.835//򒹏䌴{

	// {WnƐEWn̒rSWł̍Ƃ߂
	delta_xyz( lon1,  lat1, lon2, lat2, &dx, &dy, &dz);
	printf("gpp[^Fox:%10.6f ܓx%10.6f dx=%8.3f dy=%8.3f dz=%8.3f\n",DegToDMS(lon1),DegToDMS(lat1),dx,dy,dz);

	// dSړʂ̍
	ddx=dx-(-146.507);
	ddy=dy-507.337;
	ddz=dz-680.507;
//	printf("ddx=%8.3f ddy=%8.3f ddz=%8.3f\n",ddx,ddy,ddz);


	// pWܓxoxɍĕϊ
	std=1;//{nn
	UTMToDes( E0,  N0, Zone, std, &lat0, &lon0 );
//	printf("%13.9f %13.9f \n\n",DegToDMS(lat0), DegToDMS(lon0));
	printf("{nnFE(YW):%10.4f(m) N(XW):%10.4f(m) Zone:%2.0fn ox:%10.6f ܓx:%10.6f \n",E0,N0,Zone,DegToDMS(lon0),DegToDMS(lat0));

	// ܓxoxrSWɕϊ
	std=1;
	h0=0.0;// W0ŌvZ
	CorToxyz( lon0, lat0, h0,std,&x1,&y1,&z1);
//	printf("x1=%8.3f y1=%8.3f z1=%8.3f\n",x1,y1,z1);

	// rSW̏dSړ
	x2=x1+dx;
	y2=y1+dy;
	z2=z1+dz;
//	printf("x2=%8.3f y2=%8.3f z2=%8.3f\n",x2,y2,z2);

	// rSWܓxoxɕϊ
	std=1;
	xyzToCor( x2 , y2, z2, std, &lon2, &lat2 );
//	printf("%13.9f %13.9f \n\n",DegToDMS(lat2), DegToDMS(lon2));
	*lon=lon2;
	*lat=lat2;

	// ܓxox璼pWɍĕϊ
	std=0;
	DesToUTM( lat2, lon2, Zone, std, &E2, &N2 , &gam2);
//	printf("E(YW):%10.4f(m) N(XW):%10.4f(m) Zone:%2.0fn ^kp(+,-):%6.2f() \n",E2,N2,Zone,gam2);

	*E=E2;
	*N=N2;
	*gam=gam2;

}


void main(void)

{

	double E0, N0,  Zone, En, Nn, lat, lon, gam;

	printf("\n{nnpW琢EnnpWւ̕ϊ\n");

	//{nnpW(s)
	E0 =  -22559.1440;
	N0 = -111256.7862;
	Zone=6.0;

	JpnToGen( E0, N0,  Zone, &En, &Nn, &lat, &lon,&gam);
	printf("EnnFE(YW):%10.4f(m) N(XW):%10.4f(m) Zone:%2.0fn ox:%10.6f ܓx:%10.6f ^kp(+,-):%6.2f() \n\n",En,Nn,Zone,DegToDMS(lon),DegToDMS(lat),gam);

}

// o͗
//
//  {nnpW琢EnnpWւ̕ϊ
//  gpp[^Fox:135.451021 ܓx 34.594839 dx=-119.332 dy= 477.603 dz= 653.823
//  {nnFE(YW):-22559.1440(m) N(XW):-111256.7862(m) Zone: 6n ox:135.451021 ܓx: 34.594839
//  EnnFE(YW):-22819.7852(m) N(XW):-110910.1181(m) Zone: 6n ox:135.450000 ܓx: 35.000000 ^kp(+,- ):  8.60()












